' VBScript to automate the compiling of B4A projects when utilizing different builds
' Written by Kevin Dommer (Kevin on the B4A Forum)
' USE AT YOUR OWN RISK!

' Unless you want to tinker with the way this script works, the only things you really need to change in this script are located in the section that has =-=-=-=-=-=-=-=-=-=-=- above and below it.

' Script commands available (for customizing your builds):

' ToggleDebugInfo  -  Toggles the 'Include Debug Information' option in B4A.  WARNING: There is no way for this script to know the state of it prior to toggling, so be sure that the beginning state will always be the same, or don't use this command.

' BuildName  -  You can name your "build" here and it will be displayed in the script's output window.  This is for your information only and does nothing to your B4A project.

' JumpToHome  -  Jumps to the beginning of the code window in B4A.  Handy when you want to ensure that B4A starts searching (to replace variables) from the beginning of your code.

' ChangeVariable {ORIGINAL VARIABLE}, {NEW VARIABLE}  -  Changes a variable in your code.  Certain things are expected as follows:
	'1)  The original variable you enter here must be followed by a space and 'AutoBuild     (See the example code below for more info)
	'2)  This script will automatically add the space and 'AutoBuild to the variable you use in this script.
	'3)  This is done this way to help make sure that ONLY variables you want changed will be changed.
	'Sample Script Code:     ChangeVariable "'DemoVersion =", "DemoVersion = True"
	'In this example, the actual original line in the B4A project is:        'DemoVersion = 'AutoBuild
	'After the script changes it, the new line in the B4A project will be:        DemoVersion = True 'AutoBuild
	'Assuming you use this same uncommented variable in your code for your default testing while programming and that it is above this AutoBuild variable, uncommenting and setting this special AutoBuild variable will override your default variable value in the compiled app.

' SetPackageName {PACKAGE NAME}   -   Sets the package name for your project.

' SetAppLabel {APP LABEL}   -   Sets the App Label for your project.

' CompileProject   -   Compiles your project

' CreateAPK {APK NAME}   -   After the project is compiled, this command will create a copy of the resulting APK and rename it as specified.  It will be located in the 'build' folder, along with your originally generated APK.  If this file already exists, it will be overwritten without warning.



Option Explicit

' See if launched using wscript... if so, don't do that!
Dim oShell
Set oShell = CreateObject("Wscript.Shell")
If Not Wscript.Fullname = Wscript.Path & "\cscript.exe" Then
 oShell.Run "cmd.exe /k " & WScript.Path & "\cscript.exe " & chr(34) & Wscript.ScriptFullname & chr(34),1, False
 WScript.quit
End If

Dim ObjPath, DeviceConnected, ProjectAPK, ProjectFileName, CompileTime
Dim vOriginal, vNew, vPackageName, vAppLabel, QT
Dim i

QT = chr(34) ' Quote

If MsgBox ("Be sure that B4A is running, your project is open, and the code window has focus." & chr(13) & "Everything is automated.  DO NOT PRESS ANY BUTTONS IN B4A DURING THIS PROCESS!" & chr(13) & chr(13) & "BEGIN GENERATING BUILDS?",4,"") = 7 Then
 WScript.Echo "Aborted.  You can close this window."
WScript.Quit
End If

DeviceConnected = MsgBox ("Do you have a device or AVD connected with B4A?",4,"")

' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
' EDIT THIS SECTION TO SUIT YOUR PROJECT
ProjectFileName = "DirecTVRemote.b4a" ' The filename of your B4A project.  This script will make a backup of it.
ProjectAPK = "DirecTVRemote.apk"  ' The name of the APK that B4A generates when you compile your project.
CompileTime = 6000  ' Time in milliseconds that it takes for your project to compile.  Adjust as necessary for the project in question.  Test manually and add a few seconds.

BackupProject ProjectFileName ' Make a backup of the project file

' You can create more builds by duplicating the "CREATE BUILD" section of code and editing as required.....
' QUOTES MUST BE REPLACE WITH CHR(34)

ToggleDebugInfo  ' Leave Debug info out of the final build (normally this is on when programming)

' -----------------------------------------------------------------
' CREATE BUILD (DEMO for ANDROID)
BuildName "DEMO for ANDROID" ' Info for script window output only!
JumpToHome
ChangeVariable "'DemoVersion =", "DemoVersion = True"
ChangeVariable "'AppMarket =", "AppMarket = " & QT & "Android" & QT
SetPackageName "com.cognitial.directvremote"
CompileProject
CreateAPK "DirecTVRemoteFREE_AND.apk"
' -----------------------------------------------------------------

' -----------------------------------------------------------------
' CREATE BUILD (DEMO for AMAZON)
BuildName "DEMO for AMAZON" ' Info for script window output only!
JumpToHome
ChangeVariable "AppMarket = " & QT & "Android" & QT, "AppMarket = " & QT & "Amazon" & QT
CompileProject
CreateAPK "DirecTVRemoteFREE_AMZN.apk"
' -----------------------------------------------------------------

' -----------------------------------------------------------------
' CREATE BUILD (PRO for AMAZON)
BuildName "PRO for AMAZON" ' Info for script window output only!
JumpToHome
ChangeVariable "DemoVersion = True", "DemoVersion = False"
SetPackageName "com.cognitial.directvremotepro"
CompileProject
CreateAPK "DirecTVRemotePRO_AMZN.apk"
' -----------------------------------------------------------------

' -----------------------------------------------------------------
' CREATE BUILD (PRO for ANDROID)
BuildName "PRO for ANDROID" ' Info for script window output only!
JumpToHome
ChangeVariable "AppMarket = " & QT & "Amazon" & QT, "AppMarket = " & QT & "Android" & QT
CompileProject
CreateAPK "DirecTVRemotePRO_AND.apk"
' -----------------------------------------------------------------

' -----------------------------------------------------------------
' Reset to original state
BuildName "Reset to original state" ' Info for script window output only!
JumpToHome
ChangeVariable "DemoVersion = False" , "'DemoVersion ="  ' Re-Comment the line used by this script!  *IMPORTANT*
ChangeVariable "AppMarket = " & QT & "Android" & QT , "'AppMarket ="
SetPackageName "com.cognitial.directvremotepro"
ToggleDebugInfo
' -----------------------------------------------------------------
' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=


' done.....
WScript.Echo "Finished.  You can close this window."
WScript.Quit

' ===================================================================================
' Script commands ----------------------------------------------------------------------
Sub ChangeVariable (vOriginal, vNew)
	WScript.Echo "Changing variable: " & vOriginal & " ---> " & vNew
	oShell.AppActivate "Basic4android":WScript.Sleep 500
	oShell.SendKeys "{F3}" ' Open Search window
	WScript.Sleep 250
	SendText vOriginal & " 'AutoBuild"
	oShell.SendKeys "{TAB}"
	SendText vNew & " 'AutoBuild"
	oShell.SendKeys "{TAB}":oShell.SendKeys "{TAB}":oShell.SendKeys "{TAB}":oShell.SendKeys "{TAB}":oShell.SendKeys "{TAB}":oShell.SendKeys "{TAB}" ' tab to Replace button
	oShell.SendKeys "{ENTER}" ' Click the Replace button to 'find' the next instance of the search (should be the first one!)
	oShell.SendKeys "{ENTER}" ' Click the Replace button again to initiate the replacement
	oShell.SendKeys "{TAB}":oShell.SendKeys "{TAB}" ' tab to Close button
	oShell.SendKeys "{ENTER}"
	WScript.Sleep 2000
End Sub

Sub SetPackageName (vPackageName)
	WScript.Echo "Setting Package Name: " & vPackageName & "..."
	oShell.AppActivate "Basic4android":WScript.Sleep 250
	oShell.SendKeys "%(pp)" ' Open package Name window
	SendText vPackageName
	WScript.Sleep 2000
	oShell.SendKeys "{ENTER}"
End Sub

Sub SetAppLabel (vAppLabel)
	WScript.Echo "Setting App Label: " & vAppLabel & "..."
	oShell.AppActivate "Basic4android":WScript.Sleep 250
	oShell.SendKeys "%(pl)" ' Open package Name window
	SendText vAppLabel
	WScript.Sleep 2000
	oShell.SendKeys "{ENTER}"
End Sub

Sub CompileProject
	WScript.Echo "Compiling project..." & vPackageName
	WScript.Sleep 500
	oShell.AppActivate "Basic4android":WScript.Sleep 250
	oShell.SendKeys "%1"
	WScript.Sleep CompileTime
	WScript.Echo "Closing B4A post-compilation dialogs... "	
	If DeviceConnected = 7 then ' No device connected
		oShell.SendKeys "{ENTER}" ' Click OK to acknowledge no device connected 
		oShell.SendKeys "{TAB}":oShell.SendKeys "{ENTER}" ' Click OK to confirm compiling is done.
		Else
		oShell.SendKeys "{TAB}":oShell.SendKeys "{ENTER}" ' Click OK to confirm compiling is done.
	End If
	WScript.Sleep 250
End Sub

Sub CreateAPK (fName)
	WScript.Echo "Creating APK: " & fName & "..."
	Dim ObjFso
	Set ObjFso = CreateObject("Scripting.FileSystemObject")
	ObjPath = ".\Objects\" ' Path to the Objects folder
	ObjFso.CopyFile ObjPath & ProjectAPK, ObjPath & fName, True
	Set ObjFso = Nothing
	WScript.Echo "" ' New line
End Sub

Sub JumpToHome ' Force IDE code window to jump to beginning
	WScript.Echo "Jumping to beginning of code in IDE..."
	oShell.AppActivate "Basic4android"
	oShell.SendKeys "^{HOME}":WScript.Sleep 250
End Sub

Sub ToggleDebugInfo
	WScript.Echo "Toggling 'Include Debug Information'..."
	oShell.AppActivate "Basic4android":WScript.Sleep 250
	oShell.SendKeys "%(pi)" ' Toggle Debug Info
	WScript.Echo "" ' New line
End Sub


' Subs used by this script--------------------------------------------------------------------------------
Sub SendText (tText) ' Sends the character of the string individually as key strokes
	If tText = "" Then Exit Sub
	For i = 1 to Len(tText)
		oShell.SendKeys Mid(tText,i,1)
	Next
End Sub

Sub BuildName (tName) ' Show the build name in the VBS output window (info only)
	WScript.Echo ">>> Processing Build: " & tName & "..."
End Sub

Sub BackupProject (fName)' Make a backup copy of the project file
	WScript.Echo "Backing up the B4A project file..."
	Dim ObjFso
	Set ObjFso = CreateObject("Scripting.FileSystemObject")
	ObjFso.CopyFile ".\" & fName, ".\" & fName & ".BAK", True
	Set ObjFso = Nothing
	WScript.Echo "" ' New line
End Sub